__gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > Class Template Reference

`#include <safe_container.h>`

Inheritance diagram for __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >:
[legend]

## Public Member Functions

void | _M_swap (_Safe_container &__x) noexcept
_Safe_container & | operator= (_Safe_container &&__x) noexcept
_Safe_container & | operator= (const _Safe_container &) noexcept

## Protected Member Functions

| _Safe_container (_Safe_container &&)=default
| _Safe_container (_Safe_container &&__x, const _Alloc &__a)
| _Safe_container (const _Safe_container &)=default
_Safe_container & | _M_safe () noexcept

## Detailed Description

template<typename _SafeContainer, typename _Alloc, template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>
class __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >

Safe class dealing with some allocator dependent operations.

Definition at line 41 of file safe_container.h.

## Constructor & Destructor Documentation

## _Safe_container()

template<typename _SafeContainer , typename _Alloc , template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

__gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::_Safe_container | ( | _Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > && | __x,
|  | const _Alloc & | __a
| ) |  |

inline protected

Definition at line 60 of file safe_container.h.

## Member Function Documentation

## _M_safe()

template<typename _SafeContainer , typename _Alloc , template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

_Safe_container & __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::_M_safe | ( |  | ) |

inline protected noexcept

Definition at line 52 of file safe_container.h.

## _M_swap()

template<typename _SafeContainer , typename _Alloc , template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

void __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::_M_swap | ( | _Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > & | __x | ) |

inline noexcept

Definition at line 104 of file safe_container.h.

## operator=() [1/2]

template<typename _SafeContainer , typename _Alloc , template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

_Safe_container & __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::operator= | ( | _Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > && | __x | ) |

inline noexcept

Definition at line 81 of file safe_container.h.

## operator=() [2/2]

template<typename _SafeContainer , typename _Alloc , template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

_Safe_container & __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::operator= | ( | const _Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > & |  | ) |

inline noexcept

Definition at line 73 of file safe_container.h.

The documentation for this class was generated from the following file:

- safe_container.h